/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlvorschlag.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlagsdokument;
import de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentUK;

public abstract class AbstractWahlvorschlagsdokumentDAO extends de.ivu.elect.jee.entity.AbstractDAO<Wahlvorschlagsdokument,
        de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentPK
    , WahlvorschlagsdokumentUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractWahlvorschlagsdokumentDAO.class);

  public AbstractWahlvorschlagsdokumentDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Wahlvorschlagsdokument findByPrimaryKey(
        de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Wahlvorschlagsdokument findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Wahlvorschlagsdokument.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: WahlvorschlagNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: select o from Wahlvorschlagsdokument o where o.wahlvorschlag = ?1<br>
      * SQL: <br>
      */
     public java.util.List<Wahlvorschlagsdokument> findByWahlvorschlag( @javax.annotation.Nonnull de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlagCheckedAndAttached =  checkAndAttach(wahlvorschlag, de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag.class, "wahlvorschlag"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("WAHLVORSCHLAGSDOKUMENT.Wahlvorschlag")
                              .setParameter(1, wahlvorschlagCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlvorschlag - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Wahlvorschlagsdokument, findByWahlvorschlag - NonUniqueResultException, Parameter: "
           + ", wahlvorschlag:'"+wahlvorschlag+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlvorschlag(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentUK uk,
        de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlagsdokument findByUK(de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagsdokumentUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}